Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.hardsoftdouble
Class HardSoftDoubleScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<HardSoftDoubleScore>
          org.optaplanner.core.api.score.buildin.hardsoftdouble.HardSoftDoubleScore

All Implemented Interfaces:
  Serializable, Comparable<HardSoftDoubleScore>, FeasibilityScore<HardSoftDoubleScore>, Score<HardSoftDoubleScore>

    public final class HardSoftDoubleScore

extends AbstractScore<HardSoftDoubleScore>
implements FeasibilityScore<HardSoftDoubleScore>

This `Score` is based on 2 levels of double constraints: hard and soft. Hard constraints have priority over soft constraints.

WARNING: NOT RECOMMENDED TO USE DUE TO ROUNDING ERRORS THAT CAUSE SCORE CORRUPTION. For example, this prints false: `System.out.println((0.01 + 0.05) == (0.01 + 0.02 + 0.03));` Use `HardSoftBigDecimalScore` instead.

This class is immutable.

See Also:
  `Score`, Serialized Form

Method Summary
`HardSoftDoubleScore` | `add(HardSoftDoubleScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(HardSoftDoubleScore other)`
`HardSoftDoubleScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`double` | `getHardScore()` The total of the broken negative hard constraints and fulfilled positive hard constraints.
`double` | `getSoftScore()` The total of the broken negative soft constraints and fulfilled positive soft constraints.
`int` | `hashCode()`
`boolean` | `isFeasible()` A `Solution` is feasible if it has no broken hard constraints.
`HardSoftDoubleScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`static HardSoftDoubleScore` | `parseScore(String scoreString)`
`HardSoftDoubleScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`HardSoftDoubleScore` | `subtract(HardSoftDoubleScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of numbers representing the Score.
`String` | `toString()`
`static HardSoftDoubleScore` | `valueOf(double hardScore, double softScore)`

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, isCompatibleArithmeticArgument, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.api.score.Score
`isCompatibleArithmeticArgument`

Method Detail

### parseScore

    public static HardSoftDoubleScore parseScore(String scoreString)

### valueOf

    public static HardSoftDoubleScore valueOf(double hardScore,
                                              double softScore)

### getHardScore

    public double getHardScore()

  The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.

  Returns:
    higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

### getSoftScore

    public double getSoftScore()

  The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

  In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard score.

  Returns:
    higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

### isFeasible

    public boolean isFeasible()

  Description copied from interface: `FeasibilityScore`
  A `Solution` is feasible if it has no broken hard constraints.

  Specified by:
    `isFeasible` in interface `FeasibilityScore<HardSoftDoubleScore>`
  Returns:
    true if the hard score(s) is 0 or higher

### add

    public HardSoftDoubleScore add(HardSoftDoubleScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Specified by:
    `add` in interface `Score<HardSoftDoubleScore>`
  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public HardSoftDoubleScore subtract(HardSoftDoubleScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Specified by:
    `subtract` in interface `Score<HardSoftDoubleScore>`
  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public HardSoftDoubleScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Specified by:
    `multiply` in interface `Score<HardSoftDoubleScore>`
  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public HardSoftDoubleScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Specified by:
    `divide` in interface `Score<HardSoftDoubleScore>`
  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public HardSoftDoubleScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Specified by:
    `power` in interface `Score<HardSoftDoubleScore>`
  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new int{-0, -7}

  Specified by:
    `toLevelNumbers` in interface `Score<HardSoftDoubleScore>`
  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(HardSoftDoubleScore other)

  Specified by:
    `compareTo` in interface `Comparable<HardSoftDoubleScore>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.